testcustomcursor.c File Reference
`#include <stdlib.h>`
`#include <stdio.h>`
`#include "SDL_test_common.h"`
Include dependency graph for testcustomcursor.c:

Go to the source code of this file.

## Functions

static SDL_Cursor * | init_color_cursor (const char *file)
static SDL_Cursor * | init_system_cursor (const char *image[])
static void | quit (int rc)
void | loop ()
int | main (int argc, char *argv[])

## Variables

static const char * | arrow []
static SDLTest_CommonState * | state
int | done
static SDL_Cursor * | cursors [1+SDL_NUM_SYSTEM_CURSORS]
static int | current_cursor
static int | show_cursor

## Function Documentation

## init_color_cursor()

static SDL_Cursor* init_color_cursor | ( | const char * | file | ) |

static

Definition at line 71 of file testcustomcursor.c.

{
SDL_Cursor *cursor = NULL;
SDL_Surface *surface = SDL_LoadBMP(file);
if (surface) {
if (surface->format->palette) {
SDL_SetColorKey(surface, 1, *(Uint8 *) surface->pixels);
} else {
switch (surface->format->BitsPerPixel) {
case 15:
SDL_SetColorKey(surface, 1, (*(Uint16 *)surface->pixels) & 0x00007FFF);
break;
case 16:
SDL_SetColorKey(surface, 1, *(Uint16 *)surface->pixels);
break;
case 24:
SDL_SetColorKey(surface, 1, (*(Uint32 *)surface->pixels) & 0x00FFFFFF);
break;
case 32:
SDL_SetColorKey(surface, 1, *(Uint32 *)surface->pixels);
break;
}
}
cursor = SDL_CreateColorCursor(surface, 0, 0);
SDL_FreeSurface(surface);
}
return cursor;
}

References cursor, NULL, SDL_CreateColorCursor, SDL_FreeSurface, SDL_LoadBMP, and SDL_SetColorKey.

Referenced by main().

## init_system_cursor()

static SDL_Cursor* init_system_cursor | ( | const char * | image[] | ) |

static

Definition at line 101 of file testcustomcursor.c.

{
int i, row, col;
Uint8 data[4*32];
Uint8 mask[4*32];
int hot_x, hot_y;
i = -1;
for (row=0; row<32; ++row) {
for (col=0; col<32; ++col) {
if (col % 8) {
data[i] <<= 1;
mask[i] <<= 1;
} else {
++i;
data[i] = mask[i] = 0;
}
switch (image[4+row][col]) {
case 'X':
data[i] |= 0x01;
mask[i] |= 0x01;
break;
case '.':
mask[i] |= 0x01;
break;
case ' ':
break;
}
}
}
sscanf(image[4+row], "%d,%d", &hot_x, &hot_y);
return SDL_CreateCursor(data, mask, 32, 32, hot_x, hot_y);
}

References hot_x, i, and SDL_CreateCursor.

Referenced by main().

## loop()

void loop | ( |  | ) |

Definition at line 150 of file testcustomcursor.c.

{
int i;
SDL_Event event;
/* Check for events */
while (SDL_PollEvent(&event)) {
SDLTest_CommonEvent(state, &event, &done);
if (event.type == SDL_MOUSEBUTTONDOWN) {
if (event.button.button == SDL_BUTTON_LEFT) {
++current_cursor;
if (current_cursor == SDL_arraysize(cursors)) {
current_cursor = 0;
}
SDL_SetCursor(cursors[current_cursor]);
} else {
show_cursor = !show_cursor;
SDL_ShowCursor(show_cursor);
}
}
}
for (i = 0; i < state->num_windows; ++i) {
SDL_Renderer *renderer = state->renderers[i];
SDL_RenderClear(renderer);
SDL_RenderPresent(renderer);
}
#ifdef __EMSCRIPTEN__
if (done) {
emscripten_cancel_main_loop();
}
#endif
}

References current_cursor, cursors, done, i, SDLTest_CommonState::num_windows, renderer, SDLTest_CommonState::renderers, SDL_arraysize, SDL_BUTTON_LEFT, SDL_MOUSEBUTTONDOWN, SDL_PollEvent, SDL_RenderClear, SDL_RenderPresent, SDL_SetCursor, SDL_ShowCursor, SDLTest_CommonEvent(), show_cursor, and state.

Referenced by main().

## main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 184 of file testcustomcursor.c.

{
int i;
const char *color_cursor = NULL;
/* Enable standard application logging */
SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO);
/* Initialize test framework */
state = SDLTest_CommonCreateState(argv, SDL_INIT_VIDEO);
if (!state) {
return 1;
}
for (i = 1; i < argc;) {
int consumed;
consumed = SDLTest_CommonArg(state, i);
if (consumed == 0) {
color_cursor = argv[i];
break;
}
if (consumed < 0) {
SDLTest_CommonLogUsage(state, argv[0], NULL);
quit(1);
}
i += consumed;
}
if (!SDLTest_CommonInit(state)) {
quit(2);
}
for (i = 0; i < state->num_windows; ++i) {
SDL_Renderer *renderer = state->renderers[i];
SDL_SetRenderDrawColor(renderer, 0xA0, 0xA0, 0xA0, 0xFF);
SDL_RenderClear(renderer);
}
if (color_cursor) {
cursors[0] = init_color_cursor(color_cursor);
} else {
cursors[0] = init_system_cursor(arrow);
}
if (!cursors[0]) {
SDL_Log("Error, couldn't create cursor\n");
quit(2);
}
for (i = 0; i < SDL_NUM_SYSTEM_CURSORS; ++i) {
cursors[1+i] = SDL_CreateSystemCursor((SDL_SystemCursor)i);
if (!cursors[1+i]) {
SDL_Log("Error, couldn't create system cursor %d\n", i);
quit(2);
}
}
SDL_SetCursor(cursors[0]);
/* Main render loop */
done = 0;
#ifdef __EMSCRIPTEN__
emscripten_set_main_loop(loop, 0, 1);
#else
while (!done) {
loop();
}
#endif
for (i = 0; i < SDL_arraysize(cursors); ++i) {
SDL_FreeCursor(cursors[i]);
}
quit(0);
/* keep the compiler happy ... */
return(0);
}

References arrow, cursors, done, i, init_color_cursor(), init_system_cursor(), loop(), NULL, SDLTest_CommonState::num_windows, quit(), renderer, SDLTest_CommonState::renderers, SDL_arraysize, SDL_CreateSystemCursor, SDL_FreeCursor, SDL_INIT_VIDEO, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, SDL_LogSetPriority, SDL_NUM_SYSTEM_CURSORS, SDL_RenderClear, SDL_SetCursor, SDL_SetRenderDrawColor, SDLTest_CommonArg(), SDLTest_CommonCreateState(), SDLTest_CommonInit(), SDLTest_CommonLogUsage(), and state.

## quit()

static void quit | ( | int | rc | ) |

static

Definition at line 143 of file testcustomcursor.c.

{
SDLTest_CommonQuit(state);
exit(rc);
}

References SDLTest_CommonQuit(), and state.

Referenced by main().

## Variable Documentation

## arrow

const char* arrow[]

static

Definition at line 27 of file testcustomcursor.c.

Referenced by main().

## current_cursor

int current_cursor

static

Definition at line 138 of file testcustomcursor.c.

Referenced by loop().

## cursors

SDL_Cursor* cursors[1+SDL_NUM_SYSTEM_CURSORS]

static

Definition at line 137 of file testcustomcursor.c.

Referenced by loop(), and main().

## done

int done

Definition at line 136 of file testcustomcursor.c.

Referenced by loop(), and main().

## show_cursor

int show_cursor

static

Definition at line 139 of file testcustomcursor.c.

Referenced by loop().

## state

SDLTest_CommonState* state

static

Definition at line 135 of file testcustomcursor.c.

Referenced by loop(), main(), and quit().

image
GLeglImageOES image
Definition: SDL_opengl.h:2148
SDL_RenderPresent
#define SDL_RenderPresent
Definition: SDL_dynapi_overrides.h:346
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:203
SDL_NUM_SYSTEM_CURSORS
@ SDL_NUM_SYSTEM_CURSORS
Definition: SDL_mouse.h:60
mask
GLenum GLint GLuint mask
Definition: SDL_opengl_glext.h:657
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:70
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_PollEvent
#define SDL_PollEvent
Definition: SDL_dynapi_overrides.h:122
SDL_LOG_CATEGORY_APPLICATION
@ SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66
NULL
#define NULL
Definition: begin_code.h:167
surface
EGLSurface surface
Definition: eglext.h:248
state
static SDLTest_CommonState * state
Definition: testcustomcursor.c:135
done
int done
Definition: testcustomcursor.c:136
cursors
static SDL_Cursor * cursors[1+SDL_NUM_SYSTEM_CURSORS]
Definition: testcustomcursor.c:137
SDL_CreateSystemCursor
#define SDL_CreateSystemCursor
Definition: SDL_dynapi_overrides.h:253
quit
static void quit(int rc)
Definition: testcustomcursor.c:143
SDL_SetCursor
#define SDL_SetCursor
Definition: SDL_dynapi_overrides.h:254
SDLTest_CommonState::renderers
SDL_Renderer ** renderers
Definition: SDL_test_common.h:84
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
SDLTest_CommonCreateState
SDLTest_CommonState * SDLTest_CommonCreateState(char **argv, Uint32 flags)
Parse command line parameters and create common state.
Definition: SDL_test_common.c:59
row
GLenum GLenum void * row
Definition: SDL_opengl_glext.h:3138
init_color_cursor
static SDL_Cursor * init_color_cursor(const char *file)
Definition: testcustomcursor.c:71
SDLTest_CommonQuit
void SDLTest_CommonQuit(SDLTest_CommonState *state)
Close test window.
Definition: SDL_test_common.c:1832
SDLTest_CommonState::num_windows
int num_windows
Definition: SDL_test_common.h:77
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
SDL_Renderer
Definition: SDL_sysrender.h:122
current_cursor
static int current_cursor
Definition: testcustomcursor.c:138
SDL_BUTTON_LEFT
#define SDL_BUTTON_LEFT
Definition: SDL_mouse.h:282
init_system_cursor
static SDL_Cursor * init_system_cursor(const char *image[])
Definition: testcustomcursor.c:101
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
loop
void loop()
Definition: testcustomcursor.c:150
SDLTest_CommonArg
int SDLTest_CommonArg(SDLTest_CommonState *state, int index)
Process one common argument.
Definition: SDL_test_common.c:117
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:191
SDL_SetColorKey
#define SDL_SetColorKey
Definition: SDL_dynapi_overrides.h:453
SDL_SystemCursor
SDL_SystemCursor
Cursor types for SDL_CreateSystemCursor().
Definition: SDL_mouse.h:46
SDLTest_CommonLogUsage
void SDLTest_CommonLogUsage(SDLTest_CommonState *state, const char *argv0, const char **options)
Logs command line usage info.
Definition: SDL_test_common.c:489
arrow
static const char * arrow[]
Definition: testcustomcursor.c:27
SDL_LoadBMP
#define SDL_LoadBMP(file)
Definition: SDL_surface.h:201
hot_x
int uint32_t uint32_t uint32_t uint32_t uint32_t int drmModeModeInfoPtr mode int uint32_t uint32_t uint32_t uint32_t int32_t hot_x
Definition: SDL_kmsdrmsym.h:57
cursor
SDL_Cursor * cursor
Definition: testwm2.c:40
SDL_CreateColorCursor
#define SDL_CreateColorCursor
Definition: SDL_dynapi_overrides.h:252
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:115
SDLTest_CommonInit
SDL_bool SDLTest_CommonInit(SDLTest_CommonState *state)
Open test window.
Definition: SDL_test_common.c:764
SDL_CreateCursor
#define SDL_CreateCursor
Definition: SDL_dynapi_overrides.h:251
SDL_INIT_VIDEO
#define SDL_INIT_VIDEO
Definition: SDL.h:79
SDL_LOG_PRIORITY_INFO
@ SDL_LOG_PRIORITY_INFO
Definition: SDL_log.h:106
renderer
static SDL_Renderer * renderer
Definition: testaudiocapture.c:21
SDL_LogSetPriority
#define SDL_LogSetPriority
Definition: SDL_dynapi_overrides.h:236
SDL_RenderClear
#define SDL_RenderClear
Definition: SDL_dynapi_overrides.h:334
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
SDL_MOUSEBUTTONDOWN
@ SDL_MOUSEBUTTONDOWN
Definition: SDL_events.h:106
SDL_ShowCursor
#define SDL_ShowCursor
Definition: SDL_dynapi_overrides.h:258
SDL_Event
General event structure.
Definition: SDL_events.h:557
SDLTest_CommonEvent
void SDLTest_CommonEvent(SDLTest_CommonState *state, SDL_Event *event, int *done)
Common event handler for test windows.
Definition: SDL_test_common.c:1501
SDL_FreeCursor
#define SDL_FreeCursor
Definition: SDL_dynapi_overrides.h:257
show_cursor
static int show_cursor
Definition: testcustomcursor.c:139
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:179